unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    PaintBox1: TPaintBox;
    sbX: TScrollBar;
    sbY: TScrollBar;
    sbZ: TScrollBar;
    procedure PaintBox1Paint(Sender: TObject);
    procedure sbChange(Sender: TObject);
  private
    procedure ZeichneWuerfel;
  public
    { public declarations }
  end;

const
  Wuerfel: Array[0..7, 0..2] of Integer=(  //Korrdinaten des Würfels
    ( 1,  1,  1),
    ( 1, -1,  1),
    (-1, -1,  1),
    (-1,  1,  1),
    ( 1,  1, -1),
    ( 1, -1, -1),
    (-1, -1, -1),
    (-1,  1, -1));

  Seiten: Array[0..11, 0..1] of Integer=(  //Verbindungen der Punkte
    (0, 1), (0, 3), (0, 4), (1, 2),
    (1, 5), (2, 3), (2, 6), (3, 7),
    (4, 5), (4, 7), (5, 6), (6, 7));

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  Caption:=
    'X['+IntToStr(sbX.Position)+'] '+
    'Y['+IntToStr(sbY.Position)+'] '+
    'Z['+IntToStr(sbZ.Position)+']';
  ZeichneWuerfel;
end;

procedure TForm1.sbChange(Sender: TObject);
begin
  Repaint;
end;

procedure TForm1.ZeichneWuerfel;

  procedure RotaX(var Y, Z: Double; Winkel: Integer);
  var
    Co, Si, Wi, DY: Double;
  begin
    Wi:=Winkel * Pi / 180;
    Co:=Cos(Wi);
    Si:=Sin(Wi);
    DY:=Y * Co - Z * Si;
    Z:=Y * Si + Z * Co;
    Y:=DY;
  end;

  procedure RotaY(var X, Z: Double; Winkel: Integer);
  var
    Co, Si, Wi, DX: Double;
  begin
    Wi:=Winkel * Pi / 180;
    Co:=Cos(Wi);
    Si:=Sin(Wi);
    DX:=Z * Si + X * Co;
    Z:=Z * Co - X * Si;
    X:=DX;
  end;

  procedure RotaZ(var X, Y: Double; Winkel: Integer);
  var
    Co, Si, Wi, DX: Double;
  begin
    Wi:=Winkel * Pi / 180;
    Co:=Cos(Wi);
    Si:=Sin(Wi);
    DX:=X * Co - Y * Si;
    Y:=X * Si + Y * Co;
    X:=DX;
  end;

var
  i, aX, aY, aSize: Integer;
  X, Y, Z: Array[0..7] of Double;

begin
  aSize:=PaintBox1.ClientHeight div 4;
  for i:=0 to High(Wuerfel) do begin
    X[i]:=Wuerfel[i,0] * aSize;
    Y[i]:=Wuerfel[i,1] * aSize;
    Z[i]:=Wuerfel[i,2] * aSize;

    RotaX(Y[i], Z[i], sbX.Position);
    RotaY(X[i], Z[i], sbY.Position);
    RotaZ(X[i], Y[i], sbZ.Position);
  end;

  aX:=PaintBox1.ClientWidth div 2;
  aY:=PaintBox1.ClientHeight div 2;
  for i:=0 to High(Seiten) do begin
    if i=0 then
      PaintBox1.Canvas.Pen.Color:=clRed
    else
      PaintBox1.Canvas.Pen.Color:=clBlack;
    PaintBox1.Canvas.Line(
      aX + Round(X[Seiten[i,0]]),
      aY + Round(Y[Seiten[i,0]]),
      aX + Round(X[Seiten[i,1]]),
      aY + Round(Y[Seiten[i,1]]));
  end;
end;

end.

